
/*
*  Ump - Unnamed Math Program
*  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
*
*  See main.cpp
*/



#ifndef ADDON_FUNCTIONS_H_
#define ADDON_FUNCTIONS_H_


#include "math2.h"

using math::Variable;
using math::VariableList;

void addon_quit(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_view(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_viewall(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_print(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_text_message(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_text_menu(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_text_input(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_load(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_load_picture(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
void addon_save_picture(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);


#ifndef NO_GTK
	void addon_show(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
	void addon_message(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
	void addon_menu(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
	void addon_input(Variable *res, Variable *left, const Variable *right, VariableList *private_varlist) throw(error_obj);
#endif


#endif // ADDON_FUNCTIONS_H_
