
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2005 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#include <stdio.h>
#include <gtk/gtk.h>
#include "ump_aboutwin.h"
#include "main.h"

GtkWidget *aboutwin = 0;



void aboutwin_show(GtkWindow *parent)
{
	GtkWidget *notebook,*vbox,*label1,*label2;
	char str[200];

	if(aboutwin == 0)
	{
		aboutwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);

		gtk_window_set_title( GTK_WINDOW(aboutwin), _("About Ump - Unnamed Math Program") );
		g_signal_connect_swapped( GTK_OBJECT(aboutwin), "delete-event", G_CALLBACK(aboutwin_close),
		                          NULL );

		vbox = gtk_vbox_new( FALSE, 0 );


		snprintf( str, 200, "%s %s", PRG_NAME,PRG_VERSION );
		label1 = gtk_label_new(str);
		gtk_misc_set_alignment( GTK_MISC(label1), 0.0f, 0.5f );
		gtk_box_pack_start( GTK_BOX(vbox), label1, TRUE, TRUE, 2 );

		notebook = gtk_notebook_new();

/* Page 'About' starts */
		snprintf( str, 200, "\n%s - %s\n\nCopyright (c) %s Mattias Hultgren\n",PRG_NAME,
		          _("a math program"), PRG_DATE );

		label1 = gtk_label_new( str );
		gtk_misc_set_alignment(GTK_MISC(label1), 0.5f, 0.5f);
		gtk_misc_set_padding(GTK_MISC(label1), 2, 2);

		label2 = gtk_label_new( _("About") );
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook),label1,label2);
/* Page 'About' ends */

/* Page 'Written by' starts */
		label1 = gtk_label_new( "Mattias Hultgren" );
		gtk_misc_set_alignment(GTK_MISC(label1), 0.0f, 0.0f);
		gtk_misc_set_padding(GTK_MISC(label1), 2, 2);

		label2 = gtk_label_new( _("Written by") );
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook),label1,label2);
/* Page 'Written by' ends */

/* Page 'Translated by' starts */
		{
			const char *trans;
			if((trans = translation.get_key_c_str("ABOUT_TRANSLATERS")) == 0)
				trans = "(Untranslated)";
			label1 = gtk_label_new( trans );
		}
		gtk_misc_set_alignment(GTK_MISC(label1), 0.0f, 0.0f);
		gtk_misc_set_padding(GTK_MISC(label1), 2, 2);

		label2 = gtk_label_new( _("Translated by") );
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook),label1,label2);
/* Page 'Translated by' ends */


/* Page 'License' starts */
		{
			const char *trans;
			if((trans = translation.get_key_c_str("ABOUT_LICENSE_DESC")) == 0)
				trans = "This program is distibuted under the terms of GNU GPL v2.\nYou should have received a copy of the GNU General Public License\nalong with this program; if not, write to the Free Software Foundation,\nInc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA";
			label1 = gtk_label_new( trans );
		}
		gtk_misc_set_alignment(GTK_MISC(label1), 0.0f, 0.0f);
		gtk_misc_set_padding(GTK_MISC(label1), 2, 2);

		label2 = gtk_label_new( _("License") );
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook),label1,label2);
/* Page 'License' ends */


		gtk_box_pack_start(GTK_BOX(vbox),notebook,TRUE,TRUE,2);
		gtk_container_set_border_width(GTK_CONTAINER(notebook), 3);

		{
			GtkWidget *box,*button;
			box = gtk_hbox_new(FALSE,2);

			{
				GtkWidget *tmpimg,*tmpbox,*tmplabel;
				tmpimg = gtk_image_new_from_stock( GTK_STOCK_CLOSE, GTK_ICON_SIZE_BUTTON );

				tmplabel = gtk_label_new_with_mnemonic(button_close);

				tmpbox = gtk_hbox_new(FALSE,0);
				gtk_box_pack_start(GTK_BOX(tmpbox),tmpimg,FALSE,FALSE,2);
				gtk_box_pack_start(GTK_BOX(tmpbox),tmplabel,FALSE,FALSE,2);
				button = gtk_button_new();
				gtk_container_add(GTK_CONTAINER(button),tmpbox);
			}
			g_signal_connect(GTK_OBJECT(button), "clicked", G_CALLBACK(aboutwin_close), NULL);

			gtk_box_pack_end(GTK_BOX(box),button,FALSE,FALSE,2);

			gtk_box_pack_start(GTK_BOX(vbox),box,FALSE,FALSE,2);
		}

		gtk_container_add(GTK_CONTAINER(aboutwin),vbox);

		gtk_window_set_modal(GTK_WINDOW(aboutwin), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(aboutwin), parent);

		gtk_widget_show_all(aboutwin);
	}
	else
		gtk_window_present(GTK_WINDOW(aboutwin));
}


void aboutwin_close(void)
{
	gtk_widget_destroy(aboutwin);
	aboutwin = 0;
}
