
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#ifndef UMP_PICTUREWINDOW_H_
#define UMP_PICTUREWINDOW_H_

#include "math2.h"

extern bool picturewin_action_dont_show_dialog;
extern int32 SNAP_SIZE;

struct graph_settings
{
	bool show_code, use_antialiasing;

	int32 width, height;
	utf8_string xmin,xmax,ymin,ymax;
	picture_h::colorrgb bgcolor;

	bool grid_on;
	picture_h::colorrgb grid_color;
	utf8_string grid_scale1,grid_scale2,grid_type;

	bool axes_on;
	picture_h::colorrgb axes_color;
	utf8_string scalex,scaley;
	int32 scale_length;

	utf8_string plot_mode;
	bool show_active_page_only;

	int active_page; // 0=func 1=polar 2=par


	utf8_string polar_start, polar_stop, polar_steps, par_start, par_stop, par_steps;
	struct
	{
		picture_h::colorrgb color;
		bool show_this;
		utf8_string entry, entry2;
	}func[10], polar[10], par[5];

// the constructor sets all the default values
	graph_settings() throw(error_obj);
};



// this will create and present the picturewin
void picturewin_show( const char *title, const math::Picture &src );

void picturewin_show( const graph_settings *settings);


// this will apply the present translation to the picturewin
void picturewin_translate(void);

// this closes the picturewin (if the picturewin isn't open nothing happens)
void picturewin_close(void);



#endif
